import GoodreadsSearchModalView from "./GoodreadsSearchModalView.svelte";
import { type SearchResult } from "@data-sources/goodreads";
import { App } from "obsidian";
import { SvelteModal } from "./SvelteModal";

export class GoodreadsSearchModal extends SvelteModal<
	typeof GoodreadsSearchModalView
> {
	constructor(
		app: App,
		onSearch: (error: any, results: SearchResult[]) => void = () => {}
	) {
		super(app, GoodreadsSearchModalView, { props: { onSearch } });
	}

	static createAndOpen(app: App): Promise<SearchResult[]> {
		return new Promise((resolve, reject) => {
			const modal = new GoodreadsSearchModal(app, (error, results) => {
				modal.close();

				if (error) {
					reject(error);
					return;
				}

				resolve(results);
			});
			modal.open();
		});
	}
}
